#include "OgreVisibilityPredictor.h"
#include "OgreBoundingBoxConverter.h"
#include "DistanceQueue.h"


const static int maxInvisibleNodesSize = 50;


namespace Ogre
{
	VisibilityPredictor::VisibilityPredictor()
	{
	}

	void VisibilityPredictor::HandleProbablyVisibleObjects(GtpVisibilityPreprocessor::ViewCell *vc)
	{
		GtpVisibility::QueryQueue queryQueue;
		GtpVisibility::HierarchyNodeContainer invisibleNodes;

		// use multiqueries for the objects that are probably invisible
        GtpVisibilityPreprocessor::ObjectPvsIterator pit = vc->GetPvs().GetIterator();

		while (pit.HasMoreEntries())
		{		
			GtpVisibilityPreprocessor::Intersectable *obj = pit.Next();
            
			if (obj->Type() != GtpVisibilityPreprocessor::Intersectable::ENGINE_INTERSECTABLE)
				continue;
		
			EngineIntersectable *oi = static_cast<EngineIntersectable *>(obj);

			EntityContainer *entries = oi->GetItem();
			
			EntityContainer::const_iterator eit, eit_end = entries->end();

			for (eit = entries->begin(); eit != eit_end; ++ eit)
			{
				// collect entities for multiqueries
				//invisibleNodes.push_back(node);

				if ((int)invisibleNodes.size() >= maxInvisibleNodesSize)
				{
					// issue the batched queries
					//IssueBatchedQuery(invisibleNodes);
				}
			}
		}
	
		while(!queryQueue.empty())
		{
			unsigned int visiblePixels;

			// fetch multiquery result
			queryQueue.front().second->GetQueryResult(visiblePixels, false);

			// collect nodes assoziated with current multiquery
			GtpVisibility::HierarchyNode *node = queryQueue.front().first;

			// tested visible
			if (visiblePixels > 0)
			{
				// render nodes
				
				// we have to store and test individual nodes later
				mNodeBuffer.push_back(node);
			}

			queryQueue.pop();
		}	
	}


	void VisibilityPredictor::UpdateVisibility(GtpVisibilityPreprocessor::ViewCell *vc)
	{
		GtpVisibility::HierarchyNodeContainer::const_iterator nit, nit_end = mNodeBuffer.end();

		// test individual nodes
		for (nit = mNodeBuffer.begin(); nit != nit_end; ++ nit)
		{

		}

		// fetch query results, update PVS of view cell
		for (nit = mNodeBuffer.begin(); nit != nit_end; ++ nit)
		{

		}

		mNodeBuffer.clear();
	}
}